#
#       ----------------------
#               DBMan
# 		----------------------
#		Database Administrator
#
#         File: auth.pl
#  Description: This file contains all the authorization routines.
#       Author: Alex Krohn
#        Email: alex@gossamer-threads.com
#          Web: http://www.gossamer-threads.com/
#      Version: 2.04
#
# COPYRIGHT NOTICE:
#
# Copyright 1997 Gossamer Threads Inc.  All Rights Reserved.
#
# This program is being distributed as shareware.  It may be used and
# modified free of charge for personal, academic, government or non-profit
# use, so long as this copyright notice and the header above remain intact.
# Any commercial use should be registered.  Please also send me an email,
# and let me know where you are using this script. By using this program 
# you agree to indemnify Gossamer Threads Inc. from any liability.
#
# Selling the code for this program without prior written consent is
# expressly forbidden.  Obtain permission before redistributing this
# program over the Internet or in any other medium.  In all cases
# copyright and header must remain intact.
#
# Please check the README file for full details on registration.
# =====================================================================

##########################################################
##	HTML Globals					##
##########################################################
# Put any globals you like in here for your html pages.

##########################################################
##	Record Layout					##
##########################################################

sub html_record_form {

	my (%rec) = @_;
	($db_auto_generate and print &build_html_record_form(%rec) and return);
	
	my $font = 'Font face="sө" Size=2 Color=#003399';

	print qq|
	<TABLE WIDTH="450" CELLPADDING=0 CELLSPACING=0 BORDER=1 BGCOLOR="#FFFFCC" background="bj1.gif">
        <TR><TD ALIGN="Right" VALIGN="TOP" WIDTH="150"><$font>Hs:</FONT></TD>
                <TD VALIGN="TOP" WIDTH="475">&nbsp;<INPUT TYPE="TEXT" NAME="ID" VALUE="$rec{'ID'}" SIZE="3" MAXLENGTH="3"></TD></TR>
        <TR><TD ALIGN="Right" VALIGN="TOP"><$font>nɶ:</FONT></TD>
                <TD VALIGN="TOP">&nbsp;<INPUT TYPE="TEXT" NAME="Date" VALUE="$rec{'Date'}" SIZE="13" MAXLENGTH="13"> ~---p(άOקɶ)</TD></TR>
        <TR><TD ALIGN="Right" VALIGN="TOP"><$font>HD:</FONT></TD>
                <TD VALIGN="TOP">&nbsp;<INPUT TYPE="TEXT" NAME="Title" VALUE="$rec{'Title'}" SIZE="40" MAXLENGTH="255"></TD></TR>
        <TR><TD ALIGN="Right" VALIGN="TOP"><$font>H:</FONT></TD>
                <TD VALIGN="TOP">&nbsp;|; print &build_select_field ("Category", "$rec{'Category'}"); print qq|</TD></TR>
        <TR><TD ALIGN="Right" VALIGN="TOP"><$font>Hyz:</FONT></TD>
                <TD VALIGN="TOP">&nbsp;<TEXTAREA NAME="Description" ROWS="4" COLS="40" WRAP="VIRTUAL" MAXLENGTH="500">$rec{'Description'}</TEXTAREA></TD></TR>
        <TR><TD ALIGN="Right" VALIGN="TOP"><$font>}: </FONT></TD>
                <TD VALIGN="TOP">&nbsp;<INPUT TYPE="TEXT" NAME="URL" VALUE="$rec{'URL'}" SIZE="40" MAXLENGTH="255"></TD></TR>
        <TR><TD ALIGN="Right" VALIGN="TOP"><$font>Hӷ: </FONT></TD>
                <TD VALIGN="TOP">&nbsp;|; print &build_select_field ("Type", "$rec{'Type'}"); print qq|</TD></TR>
        <TR><TD ALIGN="Right" VALIGN="TOP"><$font>H:</FONT></TD>
                <TD VALIGN="TOP">&nbsp;<INPUT TYPE="TEXT" NAME="Author" VALUE="$rec{'Author'}" SIZE="12" MAXLENGTH="12">AjW</TD></TR>
        <TR><TD ALIGN="Right" VALIGN="TOP"><$font>qll: </FONT></TD>
                <TD VALIGN="TOP">&nbsp;<INPUT TYPE="TEXT" NAME="Mail" VALUE="$rec{'Mail'}" SIZE="22" MAXLENGTH="50"></TD></TR>
	</TABLE>
	|;



}

sub html_record {
# --------------------------------------------------------
# How a record will be displayed. This is used primarily in 
# returning search results and how it is formatted. The record to
# be displayed will be in the %rec hash.

	my (%rec) = @_;		# Load any defaults to put in the VALUE field.
	($db_auto_generate and print &build_html_record(%rec) and return);
	
	my $font_color = 'Font face="sө" Size=2 Color=#003399';
	my $font       = 'Font face="sө" Size=2';
	
	print qq|
	<TABLE WIDTH="475" CELLPADDING=0 CELLSPACING=0 BORDER=1 BGCOLOR="#FFFFCC" background="bj1.gif">
	<TR><TD ALIGN="Right" VALIGN="TOP" WIDTH="20%"><$font_color>Hs:</FONT></TD>
		<TD WIDTH="80%">&nbsp;<$font>$rec{'ID'}</Font></TD></TR>
	<TR><TD ALIGN="Right" VALIGN="TOP"><$font_color>nɶ:</FONT></TD>
		<TD>&nbsp;<$font>$rec{'Date'}</Font></TD></TR>
	<TR><TD ALIGN="Right" VALIGN="TOP"><$font_color>HD: </FONT></TD>
		<TD>&nbsp;<$font>$rec{'Title'}</Font></TD></TR>
	<TR><TD ALIGN="Right" VALIGN="TOP"><$font_color>H: </FONT></TD>
		<TD>&nbsp;<$font>$rec{'Category'}</Font></TD></TR>
	<TR><TD ALIGN="Right" VALIGN="TOP"><$font_color>Hyz:</FONT></TD>
		<TD>&nbsp;<$font>$rec{'Description'}</Font></TD></TR>
	<TR><TD ALIGN="Right" VALIGN="TOP"><$font_color>}:</FONT></TD>
		<TD>&nbsp;<$font><A HREF="$rec{'URL'}">$rec{'URL'}</A></Font></TD></TR>
	<TR><TD ALIGN="Right" VALIGN="TOP"><$font_color>Hӷ: </FONT></TD>
		<TD>&nbsp;<$font>$rec{'Type'}</Font></TD></TR>
	<TR><TD ALIGN="Right" VALIGN="TOP"><$font_color>H:</FONT></TD>
		<TD>&nbsp;<$font>$rec{'Author'}</Font></TD></TR>				
	<TR><TD ALIGN="Right" VALIGN="TOP"><$font_color>qll:</FONT></TD>
		<TD>&nbsp;<$font><A HREF="mailto:$rec{'Mail'}">$rec{'Mail'}</A></Font></TD></TR>				
	</TABLE>
	|;
	
}

##########################################################
##						Home Page  						##
##########################################################

sub html_home {
# --------------------------------------------------------
# The database manager home page.

	&html_print_headers;
	print  qq|
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=big5">

	<title>$html_title</title>
</head>

<body background="bj.gif">
	<center>
		<table border=0 cellpadding=5 cellspacing=3 width=500 align=center valign=top background="bj1.gif">
			<tr><td>
					<p><center><$font_title><b>
						$html_title
					</b></font></center><br>
					<font face="sө" size="-1"><b>
					A{blv: |;
print " d " if ($per_view);
print " W[ " if ($per_add);
print " R " if ($per_del);
print " ק " if ($per_mod);
print " ޲z " if ($per_admin);
print " S " if (!($per_view || $per_add || $per_del || per_mod));
print qq|</b></font>
					<P><$font>
                                   wiJtͤߡMzbo̧ӦPDXB͡TпܤUC
						<br><br>
					</font>
					<br><br><br>
					</p>
					<br><br><br>
					|; &html_footer; print qq|
						
			</td></tr>
		</table>
	</center>	   
</body>
</html>
|;
}

sub html_footer {
# --------------------------------------------------------
# Print the menu and the footer and logo. It would be nice if you left
# the logo in. ;)
#
# We only print options that the user have permissions for.
#

	my $font       = 'Font face="sө" Size=2';

	print qq!<P align=center><$font>!;
	print qq!| <A HREF="$db_script_link_url">^</A> !;
	print qq!| <A HREF="$db_script_link_url&add_form=1">W[</A> ! 				    if ($per_add);
	print qq!| <A HREF="$db_script_link_url&view_search=1">d</A> ! 				if ($per_view);
	print qq!| <A HREF="$db_script_link_url&delete_search=1">R</A> ! 			if ($per_del);
	print qq!| <A HREF="$db_script_link_url&modify_search=1">ק</A> ! 			if ($per_mod);
	print qq!| <A HREF="$db_script_link_url&view_records=1&$db_key=*">CX</A> ! if ($per_view);
	print qq!| <A HREF="$db_script_link_url&admin_display=1">޲z</A> ! 			if ($per_admin);
	print qq!| <A HREF="$db_script_link_url&logoff=1">}</A> |!;
	print qq!</font></p>!;

# Print the Footer.
	print qq!	
		
		<BR><BR><br><br><br>
		<table border=0 width=100%>
			<tr><td align=center><a href="http://www.gossamer-threads.com"><img src="http://www.gossamer-threads.com/images/powered.gif" width=100 height=31 alt="Gossamer Threads Inc." border=0></A></font><br>: <a href="mailto:chihin\@163.net">a</a></td></tr>
		</table>
	!;
}	

sub html_search_options {
# --------------------------------------------------------
# Search options to be displayed at the bottom of search forms.
#
# cut in select fuction
#		<OPTION>---
#	~; for (my $i =0; $i <= $#db_cols; $i++) { print qq~<OPTION VALUE="$i">$db_cols[$i]</OPTION>\n~ if ($db_form_len{$db_cols[$i]} >= 0); } print qq~

	print qq~
	<P>
	<STRONG>jﶵ:</STRONG> <br>
	<INPUT TYPE="CHECKBOX" NAME="ma"> ǰt@ 
	<INPUT TYPE="CHECKBOX" NAME="cs"> ǰtjpg 
	<INPUT TYPE="CHECKBOX" NAME="ww"> ǰt 
	<INPUT TYPE="CHECKBOX" NAME="re"> rBzҦ <BR><BR>
	bUJrij<BR>
	<INPUT TYPE="TEXT" NAME="keyword" SIZE=15 MAXLENGTH=255>  <FONT SIZE=-1> (BJrj, N|dҦrq)</FONT><BR>
	<INPUT TYPE="TEXT" NAME="mh" VALUE="$db_max_hits" SIZE=3 MAXLENGTH=3> C^̤jO<BR>
	rqƧǮھ:
	<SELECT NAME="sb">
		<OPTION>---
	~; for (my $i =0; $i <= $#db_cols; $i++) { print qq~<OPTION VALUE="$i">$db_name{$db_cols[$i]}</OPTION>\n~ if ($db_form_len{$db_cols[$i]} >= 0); } print qq~
	</SELECT>
	ƦC:
	<SELECT NAME="so">
		<OPTION VALUE="ascend">ɧ
		<OPTION VALUE="descend">
	</SELECT><br><br>
	<strong>j:</strong><br>
	&nbsp;&nbsp;&nbsp;&nbsp;- ϥ '*' N^ҦO)<BR>
	&nbsp;&nbsp;&nbsp;&nbsp;- brq}lmϥ '&gt;'  '&lt;' Ÿii歭wd򪺷j.<BR>	
	~;
}

##########################################################
##						Adding  						##
##########################################################

sub html_add_form {
# --------------------------------------------------------
# The add form page where the user fills out all the details
# on the new record he would like to add. You should use 
# &html_record_form to print out the form as it makes
# updating much easier. Feel free to edit &get_defaults
# to change the default values.

	&html_print_headers;
	print qq|
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=big5">

	<title>$html_title: W[sO.</title>
</head>

<body background="bj.gif">
	<form action="$db_script_url" method="POST">
		<input type=hidden name="db" value="$db_setup">
		<input type=hidden name="uid" value="$db_uid">	
	<center>
		<table border=1 cellpadding=5 cellspacing=3 width=500 align=center valign=top background="bj1.gif">
			<tr><td colspan=2 bgcolor="navy">
					<FONT FACE="sө" size=-1 COLOR="#FFFFFF">
                    <b>$html_title: W[sO</b>
			</td></tr>
			<tr><td>
					<p><center><$font_title><b>
						W[sO
					</b></font></center><br>
					<$font>
						|; &html_record_form (&get_defaults); print qq|
					</font></p>
					<p><center> <INPUT TYPE="SUBMIT" NAME="add_record" VALUE="W[Tw"> <INPUT TYPE="RESET" VALUE=""></center></p>
					|; &html_footer; print qq|
			</td></tr>
		</table>
	</center>	   
	</form>
</body>
</html>	
|;
}

sub html_add_success {
# --------------------------------------------------------
# The page that is returned upon a successful addition to
# the database. You should use &get_record and &html_record
# to verify that the record was inserted properly and to make
# updating easier.

	&html_print_headers;
	print qq|
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=big5">

	<title>$html_title: W[.</title>
</head>

<body background="bj.gif">
	<center>
		<table border=1 cellpadding=5 cellspacing=3 width=500 align=center valign=top background="bj1.gif">
			<tr><td colspan=2 bgcolor="navy">
					<FONT FACE="sө" size=-1 COLOR="#FFFFFF">
                    <b>$html_title: W[\</b>
			</td></tr>
			<tr><td>
					<p><center><$font_title><b>
						W[\
					</b></font></center><br>
					<$font>
						<P><Font face="Verdana, Arial, Helvetica" Size=2>UOwQ\W[iƾڮw:</FONT>
						|; &html_record(&get_record($in{$db_key})); print qq|	
					</font></p>
					|; &html_footer; print qq|
			</td></tr>
		</table>
	</center>	   
</body>
</html>		
|;
}

sub html_add_failure {
# --------------------------------------------------------
# The page that is returned if the addition failed. An error message 
# is passed in explaining what happened in $message and the form is
# reprinted out saving the input (by passing in %in to html_record_form).

	my ($message) = $_[0];
	
	&html_print_headers;
	print qq|
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=big5">

	<title>$html_title: ~! W[.</title>
</head>

<body background="bj.gif">
	<form action="$db_script_url" method="POST">
		<input type=hidden name="db" value="$db_setup">
		<input type=hidden name="uid" value="$db_uid">	
	<center>
		<table border=1 cellpadding=5 cellspacing=3 width=500 align=center valign=top background="bj1.gif">
			<tr><td colspan=2 bgcolor="navy">
					<FONT FACE="sө" size=-1 COLOR="#FFFFFF">
                    <b>$html_title: ~! W[</b>
			</td></tr>
			<tr><td>
					<p><center><$font_title><b>
						~! <font color=red>W[</font>
					</b></font></center><br>
					<$font>
						HUrqD: <FONT COLOR="red"><B>$message</B></FONT>
						<P>Эק᭫sW[.</p></font>
						|; &html_record_form (%in); print qq|
					</font></p>
					<p><center> <INPUT TYPE="SUBMIT" NAME="add_record" VALUE="W[T{"> <INPUT TYPE="RESET" VALUE=""></center></p>
					|; &html_footer; print qq|
			</td></tr>
		</table>
	</center>	   
	</form>
</body>
</html>	
|;
}

##########################################################
##						Viewing							##
##########################################################

sub html_view_search {
# --------------------------------------------------------
# This page is displayed when a user requests to search the 
# database for viewing. 
# Note: all searches must use GET method.
#
	&html_print_headers;
	print qq|
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=big5">

	<title>$html_title: jMƾڮw.</title>
</head>

<body background="bj.gif">
	<form action="$db_script_url" method="GET">
		<input type=hidden name="db" value="$db_setup">
		<input type=hidden name="uid" value="$db_uid">	
	<center>
		<table border=1 cellpadding=5 cellspacing=3 width=500 align=center valign=top background="bj1.gif">
			<tr><td colspan=2 bgcolor="navy">
					<FONT FACE="sө" size=-1 COLOR="#FFFFFF">
                    <b>$html_title: jMƾڮw</b>
			</td></tr>
			<tr><td>
					<p><center><$font_title><b>
						jMƾڮw
					</b></font></center><br>
					<$font>
						|;  &html_record_form(); print qq|
						|; &html_search_options; print qq|
					</font></p>
					<p><center> <INPUT TYPE="SUBMIT" NAME="view_records" VALUE="Tw"> <INPUT TYPE="RESET" VALUE=""></center></p>
					|; &html_footer; print qq|
			</td></tr>
		</table>
	</center>	   
	</form>
</body>
</html>	
|;
}

sub html_view_success {
# --------------------------------------------------------
# This page displays the results of a successful search. 
# You can use the following variables when displaying your 
# results:
#
#        $numhits - the number of hits in this batch of results.
#        $maxhits - the max number of hits displayed.
#        $db_total_hits - the total number of hits.
#        $db_next_hits  - html for displaying the next set of results.
#       
	
	my (@hits) = @_;
	my ($numhits) = ($#hits+1) / ($#db_cols+1);
	my ($maxhits); $in{'mh'} ? ($maxhits = $in{'mh'}) : ($maxhits = $db_max_hits);	
	
	&html_print_headers;	
	print qq|
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=big5">

	<title>$html_title: d䵲G.</title>
</head>

<body background="bj.gif">
	<blockquote>
	<table border=1 cellpadding=5 cellspacing=3 width=500 valign=top background="bj1.gif">
		<tr><td colspan=2 bgcolor="navy"><FONT FACE="sө" size=1 COLOR="#FFFFFF">
                   <b>$html_title: d䵲G</b>
		</font></td></tr>
	</table>
	<p><$font>
		@@^ <b>$db_total_hits</b> O.</font>
|;
	if ($db_next_hits) {
		print "<br><$font>: $db_next_hits</font>";
	}
	
# Go through each hit and convert the array to hash and send to 
# html_record for printing.
	for (0 .. $numhits - 1) {
		print "<P>";
		&html_record (&array_to_hash($_, @hits));
	}
	if ($db_next_hits) {
		print "<br><$font>: $db_next_hits</font>";
	}
	
	print qq|
		<p>
		<table border=0 bgcolor="#DDDDDD" cellpadding=5 cellspacing=3 width=500 valign=top>
			<tr><td>|; &html_footer; print qq|</td></tr>
		</table>
	</blockquote>
</body>
</html>
|;
}

sub html_view_failure {
# --------------------------------------------------------
# The search for viewing failed. The reason is stored in $message
# and a new search form is printed out.

	my ($message) = $_[0];
	
	&html_print_headers;
	print qq|
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=gb2312">

	<title>$html_title: d䥢.</title>
</head>

<body background="bj.gif">
	<form action="$db_script_url" method="GET">
		<input type=hidden name="db" value="$db_setup">
		<input type=hidden name="uid" value="$db_uid">	
	<center>
		<table border=1 cellpadding=5 cellspacing=3 width=500 align=center valign=top background="bj1.gif">
			<tr><td colspan=2 bgcolor="navy">
					<FONT FACE="sө" size=-1 COLOR="#FFFFFF">
                    <b>$html_title: d䥢</b>
			</td></tr>
			<tr><td>
					<p><center><$font_title><b>
						d䥢
					</b></font></center><br>
					<$font>
						<P>ѭ]: <FONT COLOR="red"><B>$message</B></FONT>
						<BR>ˬdAjM@.</p>
						|;  &html_record_form(%in); print qq|
						|; &html_search_options; print qq|</p>
					</font></p>
					<p><center> <INPUT TYPE="SUBMIT" NAME="view_records" VALUE="Tw"> <INPUT TYPE="RESET" VALUE=""></center></p>
					|; &html_footer; print qq|
			</td></tr>
		</table>
	</center>	   
	</form>
</body>
</html>
|;
}

##########################################################
##						Deleting						##
##########################################################

sub html_delete_search {
# --------------------------------------------------------
# The page is displayed when a user wants to delete records. First
# the user has to search the database to pick which records to delete.
# That's handled by this form.

	&html_print_headers;
	print qq|
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=big5">

	<title>$html_title: jMnRO.</title>
</head>

<body background="bj.gif">
	<form action="$db_script_url" method="GET">
		<input type=hidden name="db" value="$db_setup">
		<input type=hidden name="uid" value="$db_uid">	
	<center>
		<table border=1 cellpadding=5 cellspacing=3 width=500 align=center valign=topbackground="bj1.gif">
			<tr><td colspan=2 bgcolor="navy">
					<FONT FACE="sө" size=-1 COLOR="#FFFFFF">
                    <b>$html_title: jMnRO</b>
			</td></tr>
			<tr><td>
					<p><center><$font_title><b>
						jMnRO
					</b></font></center><br>
					<$font>
						<P>зjMǰtRO  CX 
						   <A HREF="$db_script_link_url&delete_form=1&$db_key=*">O</a> Hq:</p>
						|;  &html_record_form(); print qq|
						|; &html_search_options; print qq|</p>
					</font></p>
					<p><center> <INPUT TYPE="SUBMIT" NAME="delete_form" VALUE="d"> <INPUT TYPE="RESET" VALUE=""></center></p>
					|; &html_footer; print qq|
			</td></tr>
		</table>
	</center>	   
	</form>
</body>
</html>	
|;
}

sub html_delete_form {
# --------------------------------------------------------
# The user has searched the database for deletion and must now
# pick which records to delete from the records returned. This page
# should produce a checkbox with name=ID value=delete for each record.
# We have to do a little work to convert the array @hits that contains
# the search results to a hash for printing.

	my ($status, @hits) = &query("mod");	
	my ($numhits) = ($#hits+1) / ($#db_cols+1);
	my ($maxhits); $in{'mh'} ? ($maxhits = $in{'mh'}) : ($maxhits = $db_max_hits);
	my (%tmp);
	
	&html_print_headers;
	print qq|
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=big5">

	<title>$html_title: RO.</title>
</head>

<body background="bj.gif">
	<form action="$db_script_url" METHOD="POST">
		<input type=hidden name="db" value="$db_setup">
		<input type=hidden name="uid" value="$db_uid">
	
	<blockquote>
	<table border=1 cellpadding=5 cellspacing=3 width=500 valign=top background="bj1.gif">
		<tr><td colspan=2 bgcolor="navy">
				<FONT FACE="MS Sans Serif, arial,helvetica" size=1 COLOR="#FFFFFF">
                   <b>$html_title: RO</b>
		</td></tr>
	</table>
	<p><$font>
		bUҦCUO䪺pؤMιнT{RMM̤U "T{R"<br>
		@@^ <b>$db_total_hits</b> O.</font>
|;
	if ($db_next_hits) {
		print "<br><$font>: $db_next_hits</font>";
	}
# Go through each hit and convert the array to hash and send to 
# html_record for printing. Also add a checkbox with name=key and value=delete.

	if ($status ne "ok") {	# There was an error searching!
		print qq|<P><FONT COLOR="RED" SIZE=4>: $status</FONT></P>|;
	}
	else {
		print "<P>";
		for (0 .. $numhits - 1) {
			%tmp = &array_to_hash($_, @hits);
			print qq|<TABLE BORDER=0><TR><TD><INPUT TYPE=CHECKBOX NAME="$tmp{$db_key}" VALUE="delete"></TD><TD>|;
			&html_record (%tmp);
			print qq|</TD></TR></TABLE>\n|;			
		}
		if ($db_next_hits) {
			print "<br><$font>: $db_next_hits</font>";
		}
	}
	print qq|
		<p>
		<table border=0 bgcolor="#DDDDDD" cellpadding=5 cellspacing=3 width=500 valign=top>
			<tr><td>
				<p><center><INPUT TYPE="SUBMIT" name="delete_records" VALUE="T{RO"> <INPUT TYPE="RESET" VALUE=""></center></p>
				|; &html_footer; print qq|
			</td></tr>
		</table>
	</blockquote>
</body>
</html>
|;
}

sub html_delete_success {
# --------------------------------------------------------
# This page let's the user know that the records were successfully
# deleted.

	my $message = shift;

	&html_print_headers;
	print qq|
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=big5">

	<title>$html_title: R\.</title>
</head>

<body background="bj.gif">
	<center>
		<table border=1 cellpadding=5 cellspacing=3 width=500 align=center valign=top background="b1j.gif">
			<tr><td colspan=2 bgcolor="navy">
					<FONT FACE="sө" size=-1 COLOR="#FFFFFF">
                    <b>$html_title: R\.</b>
			</td></tr>
			<tr><td>
					<p><center><$font_title><b>
						R\
					</b></font></center><br>
					<$font>
						UCAܪOwQ\R: '$message'.
					</font></p>
					|; &html_footer; print qq|
			</td></tr>
		</table>
	</center>	   
</body>
</html>	
|;
}

sub html_delete_failure {
# --------------------------------------------------------
# This page let's the user know that some/all of the records were
# not deleted (because they were not found in the database). 
# $errstr contains a list of records not deleted.

	my ($errstr) = $_[0];
	
	&html_print_headers;
	print qq|
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=big5">

	<title>$html_title: : R.</title>
</head>

<body bgcolor="#DDDDDD" background="bj.gif">
	<center>
		<table border=1 bgcolor="#FFFFFF" cellpadding=5 cellspacing=3 width=500 align=center valign=top background="bj1.gif">
			<tr><td colspan=2 bgcolor="navy">
					<FONT FACE="sө" size=-1 COLOR="#FFFFFF">
                    <b>$html_title: : R</b>
			</td></tr>
			<tr><td>
					<p><center><$font_title><b>
						: <font color=red>R</font>
					</b></font></center><br>
					<$font>
						UCOSo{bƾڮw: <FONT COLOR="red">'$errstr'</FONT>.
					</font></p>
					|; &html_footer; print qq|
			</td></tr>
		</table>
	</center>	   
</body>
</html>	
|;	
}

##########################################################
##						Modifying						##
##########################################################
sub html_modify_search {
# --------------------------------------------------------
# The page is displayed when a user wants to modify a record. First
# the user has to search the database to pick which record to modify.
# That's handled by this form.

	&html_print_headers;
	print qq|
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=big5">

	<title>$html_title: jMnק諸O.</title>
</head>

<body background="bj.gif">
	<form action="$db_script_url" method="GET">
		<input type=hidden name="db" value="$db_setup">
		<input type=hidden name="uid" value="$db_uid">
	
	<center>
		<table border=1 cellpadding=5 cellspacing=3 width=500 align=center valign=top background="bj1.gif">
			<tr><td colspan=2 bgcolor="navy">
					<FONT FACE="sө" size=-1 COLOR="#FFFFFF">
                    <b>$html_title: jMnק諸O</b>
			</td></tr>
			<tr><td>
					<p><center><$font_title><b>
						jMnק諸O
					</b></font></center><br>
					<$font>
						<P>зjM@AQק諸O  
						   <A HREF="$db_script_link_url&modify_form=1&$db_key=*">O</a> Hq:</p>
						|;  &html_record_form(); print qq|
						|; &html_search_options; print qq|</p>
					</font></p>
					<p><center> <INPUT TYPE="SUBMIT" NAME="modify_form" VALUE="jM"> <INPUT TYPE="RESET" VALUE=""></center></p>
					|; &html_footer; print qq|
			</td></tr>
		</table>
	</center>	   
	</form>
</body>
</html>		
|;
}


sub html_modify_form {

	my (%tmp);
	my ($status, @hits) = &query("mod");	
	my ($numhits) = ($#hits+1) / ($#db_cols+1);
	if (($numhits == 1) and !$in{'nh'}) { $in{'modify'} = $hits[$db_key_pos]; &html_modify_form_record(); return; }
	my ($maxhits); $in{'mh'} ? ($maxhits = $in{'mh'}) : ($maxhits = $db_max_hits);

	&html_print_headers;
	print qq|
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=big5">

	<title>$html_title: קO.</title>
</head>

<body background="bj.gif">
	<form action="$db_script_url" METHOD="POST">
		<input type=hidden name="db" value="$db_setup">
		<input type=hidden name="uid" value="$db_uid">
	<blockquote>
	<table border=1 cellpadding=5 cellspacing=3 width=500 valign=top background="bj1.gif">
		<tr><td colspan=2 bgcolor="navy">
				<FONT FACE="sө" size=-1 COLOR="#FFFFFF">
                   <b>$html_title: קO</b>
		</td></tr>
	</table>
	<p><$font>
		ЦbUCAnקO䪺pؤιнT{MM̤U "קT{":<br>
		@@^ <b>$db_total_hits</b> O.</font>
|;
	if ($db_next_hits) {
		print "<br><$font>: $db_next_hits</font>";
	}

# Go through each hit and convert the array to hash and send to 
# html_record for printing. Also add a radio button with name=modify
# and value=key.
	if ($status ne "ok") {	# Error searching database!
		print qq|<P><FONT COLOR="RED" SIZE=4>~: $status</FONT>|;
	}
	else {
		print "<P>";
		for (0 .. $numhits - 1) {
			%tmp = &array_to_hash($_, @hits);
			print qq|<TABLE BORDER=0><TR><TD><INPUT TYPE=RADIO NAME="modify" VALUE="$tmp{$db_key}"></TD><TD>|;
			&html_record (%tmp);
			print qq|</TD></TR></TABLE>\n|;			
		}
		if ($db_next_hits) {
			print "<br><$font>: $db_next_hits</font>";
		}
	}
	print qq|
		<p>
		<table border=0 bgcolor="#DDDDDD" cellpadding=5 cellspacing=3 width=500 valign=top>
			<tr><td>
				<P><center><input type="SUBMIT" name="modify_form_record" value="קT{"> <INPUT TYPE="RESET" VALUE=""></center></p>
				|; &html_footer; print qq|
			</td></tr>
		</table>
	</blockquote>
</body>
</html>
|;
}

sub html_modify_form_record {

	my (%rec) = &get_record($in{'modify'});
	if (!%rec) { &html_modify_failure("unable to find record/no record specified: $in{'modify'}"); return; }

	&html_print_headers;
	print qq|
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=big5">

	<title>$html_title: ק@O.</title>
</head>

<body background="bj.gif">
	<form action="$db_script_url" method="POST">
		<input type=hidden name="db" value="$db_setup">
		<input type=hidden name="uid" value="$db_uid">	
	<center>
		<table border=1 cellpadding=5 cellspacing=3 width=500 align=center valign=top>
			<tr><td colspan=2 bgcolor="navy">
					<FONT FACE="sө" size=-1 COLOR="#FFFFFF">
                    <b>$html_title: ק@O</b>
			</td></tr>
			<tr><td>
					<p><center><$font_title><b>
						ק@O
					</b></font></center><br>
					<$font>
						|; &html_record_form (%rec); print qq|
					</font></p>
					<p><center> <INPUT TYPE="SUBMIT" NAME="modify_record" VALUE="קO"> <INPUT TYPE="RESET" VALUE=""></center></p>
					|; &html_footer; print qq|
			</td></tr>
		</table>
	</center>	   
	</form>
</body>
</html>	
|;
}

sub html_modify_success {
# --------------------------------------------------------
# The user has successfully modified a record, and this page will 
# display the modified record as a confirmation.

	&html_print_headers;
	print qq|
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=big5">

	<title>$html_title: ק令\.</title>
</head>

<body background="bj.gif">
	<center>
		<table border=1 cellpadding=5 cellspacing=3 width=500 align=center valign=top>
			<tr><td colspan=2 bgcolor="navy">
					<FONT FACE="sө" size=-1 COLOR="#FFFFFF">
                    <b>$html_title: ק令\.</b>
			</td></tr>
			<tr><td>
					<p><center><$font_title><b>
						ק令\
					</b></font></center><br>
					<$font>
						UOwQק:
					</font></p>
					|; &html_record(&get_record($in{$db_key})); print qq|
					|; &html_footer; print qq|
			</td></tr>
		</table>
	</center>	   
</body>
</html>	
|;
}

sub html_modify_failure {

	my ($message) = $_[0];
	
	&html_print_headers;
	print qq|
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=big5">

	<title>$html_title: ! ק.</title>
</head>

<body background="bj.gif">
	<form action="$db_script_url" method="POST">
		<input type=hidden name="db" value="$db_setup">
		<input type=hidden name="uid" value="$db_uid">	
	<center>	
		<table border=1 cellpadding=5 cellspacing=3 width=500 align=center valign=top>
			<tr><td colspan=2 bgcolor="navy">
					<FONT FACE="sө" size=-1 COLOR="#FFFFFF">
                    <b>$html_title: ! ק.</b>
			</td></tr>
			<tr><td>
					<p><center><$font_title><b>
						: <font color=red>ק</font>
					</b></font></center><br>
					<$font>
						bקɹJ쪺D: <FONT COLOR="red"><B>$message</B></FONT>
						<BR>Эץ᭫s.
					</font></p>					
					|; &html_record_form (%in); print qq|
					<p><center> <INPUT TYPE="SUBMIT" NAME="modify_record" VALUE="קT{"> <INPUT TYPE="RESET" VALUE=""></center></p>
					|; &html_footer; print qq|
			</td></tr>
		</table>
	</center>	   
	</form>
</body>
</html>
|;
}

##########################################################
##						Authentication					##
##########################################################
sub html_login_form {
# --------------------------------------------------------
# The login screen.

	&html_print_headers;
	print qq|
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=big5">

	<title>$html_title: .</title>
</head>
<body text="#000000" onLoad="document.form1.userid.focus()" background="bj.gif" >
	<form action="$db_script_url" method="post" name="form1">
		<input type=hidden name="db" value="$db_setup">
		<input type=hidden name="uid" value="$db_uid">	
	<center>
		<table border=1 cellpadding=5 cellspacing=3 width=500 align=center valign=top>
			<tr><td colspan=2 bgcolor="navy">
					<FONT FACE="sө" size=-1 COLOR="#FFFFFF">
                    <b>$html_title: </b>
			</td></tr>
			<tr><td>
					<p><center><$font_title>
					<b></b></font></center><br>
					<$font>AnM wӨ $html_title. F޲zAOпJbMKXC
					<table border=0>
					<tr><td><Font face="Verdana, Arial, Helvetica" Size=2 Color=#003399><b>Τb:</b></FONT></td>
						<td><input type="TEXT" name="userid"></td></tr>
					<tr><td><Font face="Verdana, Arial, Helvetica" Size=2 Color=#003399><b>ΤKX:</b></FONT></td>
						<td><input type="PASSWORD" name="pw"></td></tr>
					</table>		
					<p align=center><center><input type="SUBMIT" name="login" value="n"> <INPUT TYPE="BUTTON" NAME="logoff" VALUE="}" onclick="parent.location.href='$auth_logoff'"></center></p>
			</td></tr>
		</table>
	</center>
	</form>
</body>
</html>
|;
}

sub html_login_failure {
# --------------------------------------------------------
# There was an error loggin in. The error message is stored in $message.

	my ($message) = $_[0];
	
	&html_print_headers;
	print qq|
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=big5">

	<title>$html_title: ҥ.</title>
</head>
<body  background="bj.gif" text="#000000" onLoad="document.form1.userid.focus()">
	<form action="$db_script_url" method="post" name="form1">
		<input type=hidden name="db" value="$db_setup">
		<input type=hidden name="uid" value="$db_uid">	
	<center>
		<table border=1 cellpadding=5 cellspacing=3 width=500 align=center valign=top>
			<tr><td colspan=2 bgcolor="navy">
					<FONT FACE="sө" size=-1 COLOR=white>
                    <b>$html_title: ҥ</b>
			</td></tr>
			<tr><td>
					<p><center><$font_title>
					<b>ҥ</b></font></center><br>
					<$font>ѭ]: <font color=red><b>$message</b></font>.<br><br>
					ЦAդ@Mpô޲z<a href="mailto:hjs\@163.net"></a>.</font>
					<p>
					<table border=0>
					<tr><td><Font face="Verdana, Arial, Helvetica" Size=2 Color=#003399><b>Τb:</b></FONT></td>
						<td><input type="TEXT" name="userid" value="$in{'userid'}"></td></tr>
					<tr><td><Font face="Verdana, Arial, Helvetica" Size=2 Color=#003399><b>ΤKX:</b></FONT></td>
						<td><input type="PASSWORD" name="pw" value="$in{'pw'}"></td></tr>
					</table>		
					<p align=center><center><input type="SUBMIT" name="login" value="n"> <INPUT TYPE="SUBMIT" NAME="logoff" VALUE="}"></center></p>
			</td></tr>
		</table>
	</center>
	</form>
</body>
</html>
|;
}

sub html_admin_display {
# --------------------------------------------------------
# The displays the list of current users.

	my ($message, $user_list, $password, $permissions) = @_;

	&html_print_headers;
	print qq|
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=big5">

	<title>$html_title: Τ޲z.</title>
</head>
<body text="#000000" background="bj.gif" >
	<form action="$db_script_url" method="post">
		<input type=hidden name="db" value="$db_setup">
		<input type=hidden name="uid" value="$db_uid">	
		<input type=hidden name="admin_display" value="1">
	<center>
		<table border=1 cellpadding=5 cellspacing=3 width=500 align=center valign=top>
			<tr><td colspan=2 bgcolor="navy">
					<FONT FACE="sө" size=-1 COLOR=white>
                    <b>$html_title: Τ޲z</b>
			</td></tr>
			<tr><td>
				<p><center><$font_title>
				<b>Τ޲z</b></font></center><br>
				
				<p><$font><Font color=red><b>$message</b></font></font></p>
				<table border=0>
				  <tr><td align=right><$font>ΤM:</font></td>
					  <td>$user_list <input type=submit name=inquire value="d"> <input type=submit name=delete value="R"></td></tr>
				  <tr><td align=right><$font>sΤW:</font></td>
					  <td><input type="text" name="new_username" size="14"></td></tr>
				  <tr><td align=right><$font>ܱKX:</font></td>
					  <td><input type="text" name="password" value="$password" size="14"></td></tr>
				  <tr><td colspan=2><$font>֦v:
				  					<br>$permissions</font></td></tr>
				</table>
				<P><center><input type=submit value="Tw"></center>
				<P>|; &html_footer; print qq|
			</td></tr>
		</table>
	</center>
	</form>
</body>
</html>
|;
}

sub html_unauth {
# --------------------------------------------------------
# A user tried to do something he was not authorized for.

	&html_print_headers;
	print qq|
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=big5">

	<title>$html_title: ! Sv.</title>
</head>

<body background="bj.gif">
	<center>
		<table border=1 cellpadding=5 cellspacing=3 width=500 align=center valign=top>
			<tr><td colspan=2 bgcolor="navy">
					<FONT FACE="sө" size=-1 COLOR="#FFFFFF">
                    <b>$html_title: ! Sv.</b>
			</td></tr>
			<tr><td>
					<p><center><$font_title><b>
						: <font color=red>A٨S\઺v</font>
					</b></font></center><br>
					<$font>
						ШϥΧA֦v.
					</font>
					</p>
					|; &html_footer; print qq|
			</td></tr>
		</table>
	</center>	   
</body>
</html>
|;
}

sub html_signup_form {
# --------------------------------------------------------
# This form is displayed for new users who want to create an account.
#	
	my $error = shift;

	&html_print_headers;
	print qq|
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=big5">

	<title>$html_title: ۰ʵU.</title>
</head>
<body background="bj.gif" text="#000000" onLoad="document.form1.userid.focus()">
	<form action="$db_script_url" method="post" name="form1">
		<input type=hidden name="db" value="$db_setup">
		<input type=hidden name="uid" value="$db_uid">	
	<center>
		<table border=1 cellpadding=5 cellspacing=3 width=500 align=center valign=top>
			<tr><td colspan=2 bgcolor="navy">
					<FONT FACE="sө" size=-1 COLOR="#FFFFFF">
                    <b>$html_title: ۰ʵU</b>
			</td></tr>
			<tr><td>
					<p><center><$font_title>
					<b>ΤU</b></font></center><br>
					<$font>FإߧAۤvbMпJbWMKX.
					<p>|; if ($error) { print "<font color=red>$error</font></p>"; } print qq|
					<table border=0>
					<tr><td><Font face="Verdana, Arial, Helvetica" Size=2 Color=#003399><b>sbW:</b></FONT></td>
						<td><input type="TEXT" name="userid" value="$in{'userid'}"></td></tr>
					<tr><td><Font face="Verdana, Arial, Helvetica" Size=2 Color=#003399><b>JKX:</b></FONT></td>
						<td><input type="PASSWORD" name="pw" value="$in{'pw'}"></td></tr>
					</table>		
					<p align=center><center><input type="SUBMIT" name="signup" value="Tw"> <INPUT TYPE="SUBMIT" NAME="logoff" VALUE="}"></center></p>
			</td></tr>
		</table>
	</center>
	</form>
</body>
</html>
|;
}	

sub html_signup_success {
# --------------------------------------------------------
# The user has successfully created a new account.

	&html_print_headers;
	print qq|
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=big5">

	<title>$html_title: bU\.</title>
</head>
<body  background="bj.gif" text="#000000" onLoad="document.form1.userid.focus()">
	<form action="$db_script_url" method="post" name="form1">
		<input type=hidden name="db" value="$db_setup">
		<input type=hidden name="uid" value="$db_uid">	
	<center>
		<table border=1 cellpadding=5 cellspacing=3 width=500 align=center valign=top>
			<tr><td colspan=2 bgcolor="navy">
					<FONT FACE="sө" size=-1 COLOR="#FFFFFF">
                    <b>$html_title: bU\</b>
			</td></tr>
			<tr><td>
					<p><center><$font_title>
					<b>bU\</b></font></center><br>
					<$font>wAMsΤMЦbUJΤbMKXiJt.
					<p>
					<table border=0>
					<tr><td><Font face="Verdana, Arial, Helvetica" Size=2 Color=#003399><b>Τb:</b></FONT></td>
						<td><input type="TEXT" name="userid"></td></tr>
					<tr><td><Font face="Verdana, Arial, Helvetica" Size=2 Color=#003399><b>ΤKX:</b></FONT></td>
						<td><input type="PASSWORD" name="pw"></td></tr>
					</table>		
					<p align=center><center><input type="SUBMIT" name="login" value="n"> <INPUT TYPE="SUBMIT" NAME="logoff" VALUE="}"></center></p>
			</td></tr>
		</table>
	</center>
	</form>
</body>
</html>
|;
}

##########################################################
##						Misc     						##
##########################################################

sub html_unkown_action {
# --------------------------------------------------------
# The program received a command it did not recognize.

	&html_print_headers;
	print qq|
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=big5">

	<title>$html_title: ! DRO.</title>
</head>

<body background="bj.gif" >
	<center>
		<table border=1 cellpadding=5 cellspacing=3 width=500 align=center valign=top>
			<tr><td colspan=2 bgcolor="navy">
					<FONT FACE="sө" size=-1 COLOR="#FFFFFF">
                    <b>$html_title: ! DRO.</b>
			</td></tr>
			<tr><td>
					<p><center><$font_title><b>
						~: <font color=red>DRO</font>
					</b></font></center><br>
					<$font>
						tα@ӤzѪRO.
					</font>
					</p>
					|; &html_footer; print qq|
			</td></tr>
		</table>
	</center>	   
</body>
</html>
|;
}

sub html_print_headers {
# --------------------------------------------------------
# Print out the headers if they haven't already been printed.

	if (!$html_headers_printed) {		
		print "Content-type: text/html\n\n";
		$html_headers_printed = 1;
	}
}
1;
